build-and-push-elasticsearch:
  stage: diff-and-build
  environment:
    name: docker-elasticsearch
  script:
    - echo "Building a Docker image!"
  only:
    changes:
      - "*"
      - "elasticsearch/**/*"

diff-dev-elasticsearch:
  stage: diff-and-build
  script:
    - echo 'Running helm diff...'
  only:
    changes:
      - "*"
      - "elasticsearch/**/*"

diff-mgmt-elasticsearch:
  stage: diff-and-build
  script:
    - echo 'Running helm diff...'
  only:
    changes:
      - "*"
      - "elasticsearch/**/*"

deploy-dev-elasticsearch:
  stage: dev
  environment:
    name: dev-elasticsearch
  script:
    - echo 'Running helm upgrade...'
  only:
    refs:
      - master
    changes:
      - "*"
      - "elasticsearch/**/*"
  needs:
    - build-and-push-elasticsearch
    - diff-dev-elasticsearch
    - diff-mgmt-elasticsearch

test-dev-elasticsearch:
  stage: dev-test
  script:
    - echo 'Running smoke test...'
  only:
    refs:
      - master
    changes:
      - "*"
      - "elasticsearch/**/*"
  needs:
    - deploy-dev-elasticsearch

deploy-mgmt-elasticsearch:
  stage: mgmt
  environment:
    name: mgmt-elasticsearch
  script:
    - echo 'Running helm upgrade...'
  only:
    refs:
      - master
    changes:
      - "*"
      - "elasticsearch/**/*"
  needs:
    - test-dev-elasticsearch

test-mgmt-elasticsearch:
  stage: mgmt-test
  script:
    - echo 'Running smoke test...'
  only:
    refs:
      - master
    changes:
      - "*"
      - "elasticsearch/**/*"
  needs:
    - deploy-mgmt-elasticsearch
